Index: c/build-tools/cklength.c
===================================================================
--- c/build-tools/cklength.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/build-tools/cklength.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -11,17 +11,4 @@
  *
  * $Id$
- * $Log$
- * Revision 1.4  1995/10/06  20:00:38  joel
- * SPARC merged and successfully tested w/o interrupt support
- *
- * Revision 1.3  1995/10/06 16:32:20  joel
- * moved to new development machine and went to gcc 2.7.0
- *
- * Revision 1.2  1995/05/31  16:44:26  joel
- * fixing revision
- *
- * Revision 1.1.1.1  1995/05/11  17:35:11  joel
- * Release 3.1.15
- *
  */
 
@@ -275,6 +262,6 @@
         if (error_flag & ERR_FATAL)
         {
-            error(0, local_errno ? "fatal error, exiting" : "exiting");
-            exit(local_errno);
+            error(0, "fatal error, exiting");
+            exit(local_errno ? local_errno : 1);
         }
         else
Index: c/build-tools/eolstrip.c
===================================================================
--- c/build-tools/eolstrip.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/build-tools/eolstrip.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -9,17 +9,4 @@
  *
  * $Id$
- * $Log$
- * Revision 1.4  1995/10/06  20:00:39  joel
- * SPARC merged and successfully tested w/o interrupt support
- *
- * Revision 1.3  1995/10/06 16:32:21  joel
- * moved to new development machine and went to gcc 2.7.0
- *
- * Revision 1.2  1995/05/31  16:44:28  joel
- * fixing revision
- *
- * Revision 1.1.1.1  1995/05/11  17:35:12  joel
- * Release 3.1.15
- *
  */
 
@@ -262,6 +249,6 @@
         if (error_flag & ERR_FATAL)
         {
-            error(0, local_errno ? "fatal error, exiting" : "exiting");
-            exit(local_errno);
+            error(0, "fatal error, exiting");
+            exit(local_errno ? local_errno : 1);
         }
         else
Index: c/build-tools/src/cklength.c
===================================================================
--- c/build-tools/src/cklength.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/build-tools/src/cklength.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -11,17 +11,4 @@
  *
  * $Id$
- * $Log$
- * Revision 1.4  1995/10/06  20:00:38  joel
- * SPARC merged and successfully tested w/o interrupt support
- *
- * Revision 1.3  1995/10/06 16:32:20  joel
- * moved to new development machine and went to gcc 2.7.0
- *
- * Revision 1.2  1995/05/31  16:44:26  joel
- * fixing revision
- *
- * Revision 1.1.1.1  1995/05/11  17:35:11  joel
- * Release 3.1.15
- *
  */
 
@@ -275,6 +262,6 @@
         if (error_flag & ERR_FATAL)
         {
-            error(0, local_errno ? "fatal error, exiting" : "exiting");
-            exit(local_errno);
+            error(0, "fatal error, exiting");
+            exit(local_errno ? local_errno : 1);
         }
         else
Index: c/build-tools/src/eolstrip.c
===================================================================
--- c/build-tools/src/eolstrip.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/build-tools/src/eolstrip.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -9,17 +9,4 @@
  *
  * $Id$
- * $Log$
- * Revision 1.4  1995/10/06  20:00:39  joel
- * SPARC merged and successfully tested w/o interrupt support
- *
- * Revision 1.3  1995/10/06 16:32:21  joel
- * moved to new development machine and went to gcc 2.7.0
- *
- * Revision 1.2  1995/05/31  16:44:28  joel
- * fixing revision
- *
- * Revision 1.1.1.1  1995/05/11  17:35:12  joel
- * Release 3.1.15
- *
  */
 
@@ -262,6 +249,6 @@
         if (error_flag & ERR_FATAL)
         {
-            error(0, local_errno ? "fatal error, exiting" : "exiting");
-            exit(local_errno);
+            error(0, "fatal error, exiting");
+            exit(local_errno ? local_errno : 1);
         }
         else
Index: c/build-tools/src/unhex.c
===================================================================
--- c/build-tools/src/unhex.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/build-tools/src/unhex.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -709,6 +709,6 @@
         if (error_flag & ERR_FATAL)
         {
-            error(0, local_errno ? "fatal error, exiting" : "exiting");
-            exit(local_errno);
+            error(0, "fatal error, exiting");
+            exit(local_errno ? local_errno : 1);
         }
         else
Index: c/build-tools/unhex.c
===================================================================
--- c/build-tools/unhex.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/build-tools/unhex.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -709,6 +709,6 @@
         if (error_flag & ERR_FATAL)
         {
-            error(0, local_errno ? "fatal error, exiting" : "exiting");
-            exit(local_errno);
+            error(0, "fatal error, exiting");
+            exit(local_errno ? local_errno : 1);
         }
         else
Index: c/src/exec/libcsupport/include/rtems/assoc.h
===================================================================
--- c/src/exec/libcsupport/include/rtems/assoc.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/libcsupport/include/rtems/assoc.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,4 +1,4 @@
 /*
- *	@(#)assoc.h	1.2 - 95/06/28
+ *	@(#)assoc.h	1.4 - 95/10/25
  *	
  *
@@ -14,5 +14,5 @@
 
 typedef struct {
-    char *name;
+    const char   *name;
     unsigned32   local_value;
     unsigned32   remote_value;
@@ -25,19 +25,19 @@
 #define RTEMS_ASSOC_DEFAULT_NAME "(default)"
 
-rtems_assoc_t *rtems_assoc_ptr_by_name(rtems_assoc_t *, char *);
-rtems_assoc_t *rtems_assoc_ptr_by_value(rtems_assoc_t *, unsigned32);
-rtems_assoc_t *rtems_assoc_ptr_by_remote(rtems_assoc_t *, unsigned32);
+const rtems_assoc_t *rtems_assoc_ptr_by_name(const rtems_assoc_t *, const char *);
+const rtems_assoc_t *rtems_assoc_ptr_by_value(const rtems_assoc_t *, unsigned32);
+const rtems_assoc_t *rtems_assoc_ptr_by_remote(const rtems_assoc_t *, unsigned32);
 
-unsigned32   rtems_assoc_remote_by_local(rtems_assoc_t *, unsigned32);
-unsigned32   rtems_assoc_local_by_remote(rtems_assoc_t *, unsigned32);
-unsigned32   rtems_assoc_remote_by_name(rtems_assoc_t *, char *);
-unsigned32   rtems_assoc_local_by_name(rtems_assoc_t *, char *);
-char        *rtems_assoc_name_by_local(rtems_assoc_t *, unsigned32);
-char        *rtems_assoc_name_by_remote(rtems_assoc_t *, unsigned32);
+unsigned32   rtems_assoc_remote_by_local(const rtems_assoc_t *, unsigned32);
+unsigned32   rtems_assoc_local_by_remote(const rtems_assoc_t *, unsigned32);
+unsigned32   rtems_assoc_remote_by_name(const rtems_assoc_t *, const char *);
+unsigned32   rtems_assoc_local_by_name(const rtems_assoc_t *, const char *);
+const char  *rtems_assoc_name_by_local(const rtems_assoc_t *, unsigned32);
+const char  *rtems_assoc_name_by_remote(const rtems_assoc_t *, unsigned32);
 
-unsigned32   rtems_assoc_remote_by_local_bitfield(rtems_assoc_t *, unsigned32);
-char        *rtems_assoc_name_by_local_bitfield(rtems_assoc_t *, unsigned32, char *);
-char        *rtems_assoc_name_by_remote_bitfield(rtems_assoc_t *, unsigned32, char *);
-unsigned32   rtems_assoc_local_by_remote_bitfield(rtems_assoc_t *ap, unsigned32);
+unsigned32   rtems_assoc_remote_by_local_bitfield(const rtems_assoc_t *, unsigned32);
+char  *rtems_assoc_name_by_local_bitfield(const rtems_assoc_t *, unsigned32, char *);
+char  *rtems_assoc_name_by_remote_bitfield(const rtems_assoc_t *, unsigned32, char *);
+unsigned32   rtems_assoc_local_by_remote_bitfield(const rtems_assoc_t *, unsigned32);
 
 
Index: c/src/exec/libcsupport/include/rtems/error.h
===================================================================
--- c/src/exec/libcsupport/include/rtems/error.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/libcsupport/include/rtems/error.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,4 +1,5 @@
+
 /*
- *	@(#)error.h	1.1 - 95/08/02
+ *	@(#)error.h	1.3 - 95/10/25
  *	
  *
@@ -7,4 +8,7 @@
  *  $Id$
  */
+
+#ifndef __RTEMS_ERROR_h
+#define __RTEMS_ERROR_h
 
 /*
@@ -19,8 +23,10 @@
                              RTEMS_ERROR_PANIC) /* all */
 
-char *rtems_status_text(rtems_status_code);
-int   rtems_error(int error_code, char *printf_format, ...);
-void  rtems_panic(char *printf_format, ...);
+const char *rtems_status_text(rtems_status_code);
+int   rtems_error(int error_code, const char *printf_format, ...);
+void  rtems_panic(const char *printf_format, ...);
 
 extern int rtems_panic_in_progress;
 
+#endif
+/* end of include file */
Index: c/src/exec/libcsupport/include/rtems/libcsupport.h
===================================================================
--- c/src/exec/libcsupport/include/rtems/libcsupport.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/libcsupport/include/rtems/libcsupport.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -30,5 +30,8 @@
 );
 
+extern void malloc_dump(void);
 extern void libc_init(int reentrant);
+extern int  host_errno(void);
+extern void fix_syscall_errno(void);
 
 #ifdef __cplusplus
@@ -36,7 +39,4 @@
 #endif
 
-extern int  host_errno(void);
-extern void fix_syscall_errno(void);
-
 #endif
 /* end of include file */
Index: c/src/exec/libcsupport/src/assoc.c
===================================================================
--- c/src/exec/libcsupport/src/assoc.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/libcsupport/src/assoc.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,5 +1,5 @@
 /*
- *	@(#)assoc.c	1.4 - 95/08/02
- *	
+ *	@(#)assoc.c	1.6 - 95/10/25
+ *
  *
  * assoc.c
@@ -9,5 +9,4 @@
  */
 
-
 #include <rtems.h>
 #include "assoc.h"
@@ -19,11 +18,11 @@
 #define rtems_assoc_is_default(ap)  ((ap)->name && STREQ(ap->name, RTEMS_ASSOC_DEFAULT_NAME))
 
-rtems_assoc_t *
+const rtems_assoc_t *
 rtems_assoc_ptr_by_name(
-    rtems_assoc_t *ap,
-    char *name
-  )
-{
-    rtems_assoc_t *default_ap = 0;
+    const rtems_assoc_t *ap,
+    const char *name
+  )
+{
+    const rtems_assoc_t *default_ap = 0;
 
     if (rtems_assoc_is_default(ap))
@@ -37,11 +36,11 @@
 }
 
-rtems_assoc_t *
+const rtems_assoc_t *
 rtems_assoc_ptr_by_local(
-    rtems_assoc_t *ap,
-    unsigned32     local_value
-  )
-{
-    rtems_assoc_t *default_ap = 0;
+    const rtems_assoc_t *ap,
+    unsigned32     local_value
+  )
+{
+    const rtems_assoc_t *default_ap = 0;
 
     if (rtems_assoc_is_default(ap))
@@ -56,11 +55,11 @@
 
 
-rtems_assoc_t *
+const rtems_assoc_t *
 rtems_assoc_ptr_by_remote(
-    rtems_assoc_t *ap,
-    unsigned32     remote_value
-  )
-{
-    rtems_assoc_t *default_ap = 0;
+    const rtems_assoc_t *ap,
+    unsigned32     remote_value
+  )
+{
+    const rtems_assoc_t *default_ap = 0;
 
     if (rtems_assoc_is_default(ap))
@@ -81,9 +80,9 @@
 unsigned32
 rtems_assoc_remote_by_local(
-    rtems_assoc_t *ap,
-    unsigned32     local_value
-  )
-{
-    rtems_assoc_t *nap;
+    const rtems_assoc_t *ap,
+    unsigned32     local_value
+  )
+{
+    const rtems_assoc_t *nap;
     nap = rtems_assoc_ptr_by_local(ap, local_value);
     if (nap)
@@ -95,9 +94,9 @@
 unsigned32
 rtems_assoc_local_by_remote(
-    rtems_assoc_t *ap,
-    unsigned32     remote_value
-  )
-{
-    rtems_assoc_t *nap;
+    const rtems_assoc_t *ap,
+    unsigned32     remote_value
+  )
+{
+    const rtems_assoc_t *nap;
     nap = rtems_assoc_ptr_by_remote(ap, remote_value);
     if (nap)
@@ -109,9 +108,9 @@
 unsigned32
 rtems_assoc_remote_by_name(
-    rtems_assoc_t *ap,
-    char          *name
-  )
-{
-    rtems_assoc_t *nap;
+    const rtems_assoc_t *ap,
+    const char          *name
+  )
+{
+    const rtems_assoc_t *nap;
     nap = rtems_assoc_ptr_by_name(ap, name);
     if (nap)
@@ -123,9 +122,9 @@
 unsigned32
 rtems_assoc_local_by_name(
-    rtems_assoc_t *ap,
-    char          *name
-  )
-{
-    rtems_assoc_t *nap;
+    const rtems_assoc_t *ap,
+    const char          *name
+  )
+{
+    const rtems_assoc_t *nap;
     nap = rtems_assoc_ptr_by_name(ap, name);
     if (nap)
@@ -140,23 +139,27 @@
  */
 
-char *
+const char *
 rtems_assoc_name_bad(
     unsigned32 bad_value
 )
 {
+#ifdef RTEMS_DEBUG
     static char bad_buffer[32];
 
     sprintf(bad_buffer, "< %d [0x%x] >", bad_value, bad_value);
+#else
+    static char bad_buffer[32] = "<assoc.c: BAD NAME>";
+#endif
     return bad_buffer;
 }
 
 
-char *
+const char *
 rtems_assoc_name_by_local(
-    rtems_assoc_t *ap,
-    unsigned32     local_value
-  )
-{
-    rtems_assoc_t *nap;
+    const rtems_assoc_t *ap,
+    unsigned32     local_value
+  )
+{
+    const rtems_assoc_t *nap;
     nap = rtems_assoc_ptr_by_local(ap, local_value);
     if (nap)
@@ -166,11 +169,11 @@
 }
 
-char *
+const char *
 rtems_assoc_name_by_remote(
-    rtems_assoc_t *ap,
-    unsigned32     remote_value
-  )
-{
-    rtems_assoc_t *nap;
+    const rtems_assoc_t *ap,
+    unsigned32     remote_value
+  )
+{
+    const rtems_assoc_t *nap;
     nap = rtems_assoc_ptr_by_remote(ap, remote_value);
     if (nap)
@@ -186,5 +189,5 @@
 
 unsigned32 rtems_assoc_remote_by_local_bitfield(
-    rtems_assoc_t *ap,
+    const rtems_assoc_t *ap,
     unsigned32     local_value
   )
@@ -202,5 +205,5 @@
 
 unsigned32 rtems_assoc_local_by_remote_bitfield(
-    rtems_assoc_t *ap,
+    const rtems_assoc_t *ap,
     unsigned32     remote_value
   )
@@ -216,6 +219,7 @@
 }
 
-char *rtems_assoc_name_by_remote_bitfield(
-    rtems_assoc_t *ap,
+char *
+rtems_assoc_name_by_remote_bitfield(
+    const rtems_assoc_t *ap,
     unsigned32     value,
     char          *buffer
@@ -237,6 +241,7 @@
 }
 
-char *rtems_assoc_name_by_local_bitfield(
-    rtems_assoc_t *ap,
+char *
+rtems_assoc_name_by_local_bitfield(
+    const rtems_assoc_t *ap,
     unsigned32     value,
     char          *buffer
Index: c/src/exec/libcsupport/src/error.c
===================================================================
--- c/src/exec/libcsupport/src/error.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/libcsupport/src/error.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,9 +1,8 @@
 /*
- *	@(#)error.c	1.2 - 95/08/02
+ *	@(#)error.c	1.6 - 95/12/12
  *	
  *
- * report errors and panics to RTEMS' stderr.
- * Currently just used by RTEMS monitor.
- *
+ *  report errors and panics to RTEMS' stderr.
+ *  Currently just used by RTEMS monitor.
  *
  *  $Id$
@@ -98,5 +97,5 @@
 
 
-char *
+const char *
 rtems_status_text(
     rtems_status_code status
@@ -109,5 +108,5 @@
 static int rtems_verror(
     unsigned32   error_flag,
-    char        *printf_format,
+    const char   *printf_format,
     va_list      arglist
 )
@@ -182,5 +181,5 @@
 int rtems_error(
     int   error_flag,
-    char *printf_format,
+    const char *printf_format,
     ...
   )
@@ -201,5 +200,5 @@
 
 void rtems_panic(
-    char *printf_format,
+    const char *printf_format,
     ...
   )
Index: c/src/exec/libcsupport/src/libio.c
===================================================================
--- c/src/exec/libcsupport/src/libio.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/libcsupport/src/libio.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -16,5 +16,5 @@
 #include <stdio.h>                      /* O_RDONLY, et.al. */
 #include <fcntl.h>                      /* O_RDONLY, et.al. */
-#include <sys/fcntl.h>                      /* O_RDONLY, et.al. */
+
 #if defined(solaris2)
 #define O_NDELAY O_NONBLOCK
@@ -22,4 +22,5 @@
 #define O_NDELAY _FNBIO
 #endif
+
 #include <errno.h>
 #include <string.h>                     /* strcmp */
@@ -209,5 +210,5 @@
             rc = rtems_semaphore_create(
               RTEMS_LIBIO_IOP_SEM(iop - rtems_libio_iops),
-              1, 
+              1,
               RTEMS_BINARY_SEMAPHORE | RTEMS_INHERIT_PRIORITY | RTEMS_PRIORITY,
               RTEMS_NO_PRIORITY,
Index: c/src/exec/libcsupport/src/no_libc.c
===================================================================
--- c/src/exec/libcsupport/src/no_libc.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/libcsupport/src/no_libc.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -1,3 +1,3 @@
-#if  !defined(RTEMS_LIBC) && !defined(RTEMS_NEWLIB) && !defined(RTEMS_UNIX)
+#if  !defined(RTEMS_NEWLIB) && !defined(RTEMS_UNIX)
 
 /*  no_libc.h
Index: c/src/exec/rtems/headers/types.h
===================================================================
--- c/src/exec/rtems/headers/types.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/rtems/headers/types.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -34,10 +34,16 @@
 typedef unsigned16      rtems_unsigned16; /* unsigned 16-bit value */
 typedef unsigned32      rtems_unsigned32; /* unsigned 32-bit value */
-typedef unsigned64      rtems_unsigned64; /* unsigned 64-bit value */
 
 typedef signed8         rtems_signed8;    /* signed 8-bit value  */
 typedef signed16        rtems_signed16;   /* signed 16-bit value */
 typedef signed32        rtems_signed32;   /* signed 32-bit value */
+
+/*
+ * some C++ compilers (eg: HP's) don't do 'long long'
+ */
+#if defined(__GNUC__)
+typedef unsigned64      rtems_unsigned64; /* unsigned 64-bit value */
 typedef signed64        rtems_signed64;   /* signed 64-bit value */
+#endif
 
 typedef single_precision rtems_single;    /* single precision float */
Index: c/src/exec/rtems/include/rtems/rtems/types.h
===================================================================
--- c/src/exec/rtems/include/rtems/rtems/types.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/rtems/include/rtems/rtems/types.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -34,10 +34,16 @@
 typedef unsigned16      rtems_unsigned16; /* unsigned 16-bit value */
 typedef unsigned32      rtems_unsigned32; /* unsigned 32-bit value */
-typedef unsigned64      rtems_unsigned64; /* unsigned 64-bit value */
 
 typedef signed8         rtems_signed8;    /* signed 8-bit value  */
 typedef signed16        rtems_signed16;   /* signed 16-bit value */
 typedef signed32        rtems_signed32;   /* signed 32-bit value */
+
+/*
+ * some C++ compilers (eg: HP's) don't do 'long long'
+ */
+#if defined(__GNUC__)
+typedef unsigned64      rtems_unsigned64; /* unsigned 64-bit value */
 typedef signed64        rtems_signed64;   /* signed 64-bit value */
+#endif
 
 typedef single_precision rtems_single;    /* single precision float */
Index: c/src/exec/score/cpu/hppa1.1/cpu.c
===================================================================
--- c/src/exec/score/cpu/hppa1.1/cpu.c	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/score/cpu/hppa1.1/cpu.c	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -25,27 +25,14 @@
 void hppa_external_interrupt_disable(unsigned32);
 void hppa_external_interrupt(unsigned32, CPU_Interrupt_frame *);
-
-/*
- * Our interrupt handlers take a 2nd argument:
- *   a pointer to a CPU_Interrupt_frame
- * So we use our own prototype instead of rtems_isr_entry
- */
-
-typedef void ( *hppa_rtems_isr_entry )(
-    ISR_Vector_number,
-    CPU_Interrupt_frame *
- );
-
-
-/*
- * who are we?  cpu number
- * Not used by executive proper, just kept (or not) as a convenience
- * for libcpu and libbsp stuff that wants it.
- *
- * Defaults to 0.  If the BSP doesn't like it, it can change it.
- */
-
-int cpu_number;                 /* from 0; cpu number in a multi cpu system */
-
+void hppa_cpu_halt(unsigned32);
+
+/*
+ * The first level interrupt handler for first 32 interrupts/traps.
+ * Indexed by vector; generally each entry is _Generic_ISR_Handler.
+ * Some TLB traps may have their own first level handler.
+ */
+
+extern void _Generic_ISR_Handler(void);
+unsigned32 HPPA_first_level_interrupt_handler[HPPA_INTERNAL_INTERRUPTS];
 
 /*  _CPU_Initialize
@@ -87,4 +74,18 @@
 
     /*
+     * Init the first level interrupt handlers
+     */
+
+    for (i=0; i <= HPPA_INTERNAL_INTERRUPTS; i++)
+        HPPA_first_level_interrupt_handler[i] = (unsigned32) _Generic_ISR_Handler;
+
+    /*
+     * Init the 2nd level interrupt handlers
+     */
+
+    for (i=0; i <= CPU_INTERRUPT_NUMBER_OF_VECTORS; i++)
+        _ISR_Vector_table[i] = (ISR_Handler_entry) hppa_cpu_halt;
+
+    /*
      * Stabilize the interrupt stuff
      */
@@ -97,4 +98,31 @@
 
     iva_table = (unsigned32) IVA_Table;
+#if defined(hppa1_1)
+    /*
+     * HACK:  (from PA72000 TRM, page 4-19)
+     * "The hardware TLB miss handler will never attempt to service
+     *  a non-access TLB miss or a TLB protection violation.  It
+     *  will only attempt to service TLB accesses that would cause
+     *  Trap Numbers 6 (Instruction TLB miss) and 15 (Data TLB miss)."
+     *
+     * The LPA instruction is used to translate a virtual address to
+     * a physical address, however, if the requested virtual address
+     * is not currently resident in the TLB, the hardware TLB miss
+     * handler will NOT insert it.  In this situation Trap Number
+     * #17 is invoked (Non-access Data TLB miss fault).
+     *
+     * To work around this, a dummy data access is first performed
+     * to the virtual address prior to the LPA.  The dummy access
+     * causes the TLB entry to be inserted (if not already present)
+     * and then the following LPA instruction will not generate
+     * a non-access data TLB miss fault.
+     *
+     * It is unclear whether or not this behaves the same way for
+     * the PA8000.
+     * 
+     */
+    iva = *(volatile unsigned32 *)iva_table;  /* dummy access */
+#endif
+
     HPPA_ASM_LPA(0, iva_table, iva);
     set_iva(iva);
@@ -113,6 +141,6 @@
     HPPA_ASM_SSM(0, level);	/* change no bits; just get copy */
     if (level & HPPA_PSW_I)
-        return 1;
-    return 0;
+        return 0;
+    return 1;
 }
 
@@ -185,10 +213,6 @@
  *
  *  TODO:
- *    delete interrupt.c etc.
  *    Count interrupts
  *    make sure interrupts disabled properly
- *    should handler check again for more interrupts before exit?
- *    How to enable interrupts from an interrupt handler?
- *    Make sure there is an entry for everything in ISR_Vector_Table
  */
 
@@ -209,14 +233,12 @@
 
     /* mark them all unused */
-
     DISABLE(~0);
     DISMISS(~0);
 
     /* install the external interrupt handler */
-  _CPU_ISR_install_vector(
-    HPPA_INTERRUPT_EXTERNAL_INTERRUPT,
-    (proc_ptr)hppa_external_interrupt,
-    &ignore
-  );
+    _CPU_ISR_install_vector(
+        HPPA_INTERRUPT_EXTERNAL_INTERRUPT,
+	(proc_ptr)hppa_external_interrupt, &ignore
+);
 }
 
@@ -257,17 +279,19 @@
        vector, iframe->Interrupt.pcoqfront);
 */
-    DISMISS(VECTOR_TO_MASK(vector));
-    DISABLE(VECTOR_TO_MASK(vector));
-}
-
-void
-hppa_external_interrupt_report_spurious(unsigned32           spurious,
+}
+
+void
+hppa_external_interrupt_report_spurious(unsigned32           spurious_mask,
                                         CPU_Interrupt_frame *iframe)
 {
     int v;
     for (v=0; v < HPPA_EXTERNAL_INTERRUPTS; v++)
-        if (VECTOR_TO_MASK(v) & spurious)
+        if (VECTOR_TO_MASK(v) & spurious_mask)
+        {
+            DISMISS(VECTOR_TO_MASK(v));
+            DISABLE(VECTOR_TO_MASK(v));
             hppa_external_interrupt_spurious_handler(v, iframe);
-    DISMISS(spurious);
+        }
+    DISMISS(spurious_mask);
 }
 
@@ -305,5 +329,5 @@
                 DISMISS(m);
                 mask &= ~m;
-                (*handler)(global_vector, iframe);
+                handler(global_vector, iframe);
             }
         }
@@ -311,10 +335,10 @@
         if (mask != 0) {
             if ( _CPU_Table.spurious_handler )
-              (*((hppa_rtems_isr_entry) _CPU_Table.spurious_handler))(
-                  mask,
-                  iframe
-                );
+            {
+                handler = (hppa_rtems_isr_entry) _CPU_Table.spurious_handler;
+                handler(mask, iframe);
+            }
             else
-              hppa_external_interrupt_report_spurious(mask, iframe);
+                hppa_external_interrupt_report_spurious(mask, iframe);
         }
     }
@@ -331,6 +355,5 @@
 
 void
-hppa_cpu_halt(unsigned32 type_of_halt,
-              unsigned32 the_error)
+hppa_cpu_halt(unsigned32 the_error)
 {
     unsigned32 isrlevel;
@@ -338,5 +361,5 @@
     _CPU_ISR_Disable(isrlevel);
 
-    asm volatile( "copy %0,%%r1" : : "r" (the_error) );
+    HPPA_ASM_LABEL("_hppa_cpu_halt");
     HPPA_ASM_BREAK(1, 0);
 }
Index: c/src/exec/score/cpu/hppa1.1/cpu.h
===================================================================
--- c/src/exec/score/cpu/hppa1.1/cpu.h	(revision 5c491aef41558df022032b543d826ef4e49493b5)
+++ c/src/exec/score/cpu/hppa1.1/cpu.h	(revision c64e4ed48285a0c944905bc02de89c20038f428b)
@@ -197,4 +197,15 @@
 
 /*
+ * Our interrupt handlers take a 2nd argument:
+ *   a pointer to a CPU_Interrupt_frame
+ * So we use our own prototype instead of rtems_isr_entry
+ */
+
+typedef void ( *hppa_rtems_isr_entry )(
+    unsigned32,
+    CPU_Interrupt_frame *
+ );
+
+/*
  * The following table contains the information required to configure
  * the HPPA specific parameters.
@@ -227,5 +238,5 @@
   unsigned32   external_interrupt[HPPA_EXTERNAL_INTERRUPTS];
 
-  void       (*spurious_handler)( unsigned32 mask, CPU_Interrupt_frame *);
+  hppa_rtems_isr_entry spurious_handler;
 
   unsigned32   itimer_clicks_per_microsecond; /* for use by Clock driver */
@@ -239,12 +250,16 @@
 EXTERN void               *_CPU_Interrupt_stack_high;
 
+/* entry points */
+void hppa_external_interrupt_spurious_handler(unsigned32, CPU_Interrupt_frame *);
+
 #endif          /* ! ASM */
 
 /*
- *  context size area for floating point
+ *  context sizes
  */
 
 #ifndef ASM
-#define CPU_CONTEXT_FP_SIZE sizeof( Context_Control_fp )
+#define CPU_CONTEXT_SIZE     sizeof( Context_Control )
+#define CPU_CONTEXT_FP_SIZE  sizeof( Context_Control_fp )
 #endif
 
@@ -440,7 +455,7 @@
  */
 
-void    hppa_cpu_halt(unsigned32 type_of_halt, unsigned32 the_error);
+void    hppa_cpu_halt(unsigned32 the_error);
 #define _CPU_Fatal_halt( _error ) \
-    hppa_cpu_halt(0, _error)
+    hppa_cpu_halt(_error)
 
 /* end of Fatal Error manager macros */
